# login

![Version: 0.0.2](https://img.shields.io/badge/Version-0.0.2-informational?style=flat-square) ![AppVersion: v0.0.2](https://img.shields.io/badge/AppVersion-v0.0.2-informational?style=flat-square)

## Prerequisites

- Kubernetes 1.19+
- Helm 3+

## Install Helm Chart

```console
helm install [RELEASE_NAME] -f values.yaml .
```

_See [configuration](#configuration) below._

_See [helm install](https://helm.sh/docs/helm/helm_install/) for command documentation._

## Dependencies

By default this chart installs additional, dependent charts:

- [nats](https://nats-io.github.io/k8s/helm/charts/)
- [redis](https://github.com/bitnami/charts/tree/main/bitnami/redis)
To disable dependencies during installation, see [multiple releases](#multiple-releases) below.

_See [helm dependency](https://helm.sh/docs/helm/helm_dependency/) for command documentation._

## Uninstall Helm Chart

```console
helm uninstall [RELEASE_NAME]
```

This removes all the Kubernetes components associated with the chart and deletes the release.

_See [helm uninstall](https://helm.sh/docs/helm/helm_uninstall/) for command documentation._

## Upgrading Chart

```console
# Upgrade chart to development environment values
helm upgrade -f values-dev.yaml [RELEASE_NAME] .
```

## Configuration

See [Customizing the Chart Before Installing](https://helm.sh/docs/intro/using_helm/#customizing-the-chart-before-installing). To see all configurable options with detailed comments:

```console
helm show values .
```

### Secrets

The following Helm template snippet demonstrates how to use Kubernetes secrets in your Helm charts:

```yaml
{{- range $key, $value := .Values.secretEnv }}
- name: "{{ $key }}"
  valueFrom:
    secretRef:
      name: "{{ $value.name }}"
{{- end }}
```
This template iterates over a list of secret environment variables specified in the Helm chart values file (values.yaml). For each secret environment variable defined, it retrieves the corresponding value from a Kubernetes Secret and injects it into the container as an environment variable.

#### How to use

To utilize this template in your Helm charts, follow these steps:

    Define Secret Environment Variables: In your Helm chart values.yaml file, define a list of secret environment variables along with the names of the corresponding Kubernetes Secret objects. For example:

```yaml
secretEnv:
  DB_PASSWORD: 
    name: my-db-secret
  API_KEY:
    name: api-key-secret
```
In this example, DB_PASSWORD and API_KEY are the environment variable names, and my-db-secret and api-key-secret are the names of the Kubernetes Secret objects containing the respective values.

Update Helm Template: Update your Helm chart template file (e.g., deployment.yaml) to include the provided template snippet. This will dynamically fetch the values of the secret environment variables from the specified Kubernetes Secrets and inject them into your container.

Deploy Helm Chart: Deploy your Helm chart to your Kubernetes cluster using the helm install command.

Edit Helm Chart Values: Open the values.yaml file in your Helm chart and configure the following values:

    useConfigMap: Set to true to use a ConfigMap, or false otherwise.
    configMapName: Name of the ConfigMap containing environment variables.
    useSecretRef: Set to true to use a Secret, or false otherwise.
    secretRefName: Name of the Secret containing sensitive environment variables.
    
### Istio intergration

Optional Istio integration is done the following way in the `values.yaml` file:

```yaml
istio:
  injection:
    pod: true
```

You may also `helm show values` on this chart's [dependencies](#dependencies) for additional options

## Values

| Key | Type | Default | Description |
|-----|------|---------|-------------|
| autoscaling.enabled | bool | `false` | Enable autoscaling |
| configMapName | string | `"my-configmap"` | The name of the ConfigMap containing environment variables |
| image.name | string | `"tsa/login"` | The name of the Docker image |
| image.pullPolicy | string | `"IfNotPresent"` | The pull policy for the Docker image |
| image.pullSecrets | string | `"deployment-key-light"` | The secret used for pulling the Docker image |
| image.repository | string | `"node-654e3bca7fbeeed18f81d7c7.ps-xaas.io"` | The repository for the Docker image |
| image.sha | string | `""` | The SHA of the Docker image, usually generated by the CI. Uses image.tag if empty |
| image.tag | string | `"latest"` | The tag of the Docker image. Uses .Chart.AppVersion if empty |
| ingress.annotations."cert-manager.io/cluster-issuer" | string | `"letsencrypt-production-http"` | Annotations for the Cert-Manager cluster issuer |
| ingress.annotations."kubernetes.io/ingress.class" | string | `"nginx"` | Annotations for the Ingress |
| ingress.annotations."nginx.ingress.kubernetes.io/rewrite-target" | string | `"/$2"` | Annotations for the Nginx Ingress Controller |
| ingress.enabled | bool | `true` | Enable Ingress |
| ingress.frontendDomain | string | `"tsa.xfsc.dev"` | The frontend domain for the Ingress |
| ingress.frontendTlsSecretName | string | `"cert-manager-tls"` | The name of the TLS secret for the Ingress |
| ingress.tlsEnabled | bool | `true` | Enable TLS for the Ingress |
| log.encoding | string | `"json"` | The encoding format for logging |
| log.level | string | `"DEBUG"` | The log level for logging |
| login.addr | string | `""` | The address for login service |
| login.http.host | string | `""` | The host for the login HTTP service |
| login.http.idle | string | `"120s"` | The idle timeout for the login HTTP service |
| login.http.port | int | `8080` | The port for the login HTTP service |
| login.http.read | string | `"10s"` | The read timeout for the login HTTP service |
| login.http.write | string | `"3m"` | The write timeout for the login HTTP service |
| login.link | string | `""` | The link for login |
| login.ocm.addr | string | `"https://tsa.xfsc.dev/ocm-ui"` | The address for OCM |
| login.ocm.cred.id | string | `""` | The ID for OCM credentials |
| login.ocm.poll.interval | string | `"1s"` | The polling interval for OCM |
| login.ocm.poll.timeout | string | `"3m"` | The polling timeout for OCM |
| login.ocm.schema.id | string | `""` | The ID for OCM schema |
| login.pass | string | `""` | The password for login |
| login.policy.addr | string | `"http://policy:8080"` | The address for policy service |
| login.policy.login | string | `"/example/loginEmail/1.0/evaluation"` | The login policy |
| login.rsa.priv | string | `""` | The RSA private key for login |
| login.rsa.pub | string | `""` | The RSA public key for login |
| login.sender | string | `"no-reply@xfsc.dev"` | The sender for login |
| login.token.audience | string | `""` | The audience for login token |
| login.token.expiration | string | `"1h"` | The expiration time for login token |
| login.token.issuer | string | `""` | The issuer for login token |
| login.user | string | `""` | The username for login |
| metrics.enabled | bool | `true` | Enable Prometheus metrics |
| metrics.port | int | `2112` | The port for Prometheus metrics |
| name | string | `"login"` | The name of the application |
| nameOverride | string | `""` | Overrides the application name |
| podAnnotations | object | `{}` | Annotations for the pods |
| replicaCount | int | `2` | The number of instances to start |
| resources.limits.cpu | string | `"300m"` | The CPU limit for the resources |
| resources.limits.memory | string | `"256Mi"` | The memory limit for the resources |
| resources.requests.cpu | string | `"50m"` | The CPU request for the resources |
| resources.requests.memory | string | `"128Mi"` | The memory request for the resources |
| secretRefName | string | `"my-secret"` | The name of the Secret containing sensitive data |
| security.runAsNonRoot | bool | `false` | Indicates if apps run as non-root by default |
| service.port | int | `8080` | The port for the service |
| useConfigMap | bool | `false` | Indicates whether to use a ConfigMap for environment variables |
| useSecretRef | bool | `false` | Indicates whether to use a Secret for sensitive data |
